//internet.h

// 0x00-0x7F: Disk sector buffer
// 0x80-0x81: Sector number
// 0x82: Disk command:
//  0: Idle/success
//  1: Read Disk Name
//  2: Write Disk Name
//  3: Read Disk Serial
//  4: Read Disk Sector
//  5: Write Disk Sector
//  0xFF: Command failure

typedef enum {
	INTERNET_IDLE		= 0,
	DOWNLOAD_WEBSITE	= 1,
	CLEAR_WEBSITE		= 2,
	INTERNET_FAIL		= 0xFF 
} InternetCommand;

typedef struct Internet {
	//RAM
	char command;
	char url[50];
	unsigned int sector_num;
	//ROM
	unsigned int sector_count;
	char webbuf[0x80];
} Internet;

